#include <stdlib.h>
#include <packet.h>

#include <firestorm.h>
#include <plugin.h>
#include <generator.h>
#include <alert.h>
#include <signature.h>
#include <decode.h>
#include <preproc.h>

PLUGIN_STD_DEFS();

/* Internet group messaging protocol */
void igmp_decode(struct packet *p)
{
	struct layer *l=&p->layer[p->llen];

	if ( l->h.raw+sizeof(struct pkt_igmphdr) > p->end ) {
		return;
	}

	p->llen++;
}

int _PLUGIN_INIT (struct plugin_in *in, struct plugin_out *out)
{
	proc_decode_add decode_add;
	static struct proto igmp_p=init_proto("igmp", igmp_decode, NULL);
	static struct proto_req igmp_r[]={
		proto_request("ip", 2),
		null_request()
	};

	plugin_check(in, out);

	PLUGIN_ID("decode.igmp", "Internet Group Messaging Protocol");
	PLUGIN_VERSION(2, 0);
	PLUGIN_AUTHOR("Gianni Tedesco", "gianni@scaramanga.co.uk");
	PLUGIN_LICENSE("GPL");

	if ( !(decode_add=in->import("decode.add")) ) {
		return PLUGIN_ERR_OBJECT;
	}

	return decode_add(&igmp_p, igmp_r) ? PLUGIN_ERR_OK : PLUGIN_ERR_FAIL;
}

int _PLUGIN_UNLOAD (int code) {
	return PLUGIN_ERR_OK;
}
