#include "match_ip.h"
PLUGIN_STD_DEFS();

int uci_compare(void *p1, void *p2)
{
	unsigned char t1=(unsigned char)((unsigned int)p1&0xff);
	unsigned char t2=(unsigned char)((unsigned int)p2&0xff);

	if ( t1==t2 ) return 0;
	return 1;
}

int _PLUGIN_INIT (struct plugin_in *in, struct plugin_out *out)
{
	int ok=0;
	proc_matcher_add matcher_add;
	
	plugin_check(in, out);
	
	PLUGIN_ID("match.ip", "IP matching routines");
	PLUGIN_VERSION(2, 0);
	PLUGIN_AUTHOR("Gianni Tedesco", "gianni@scaramanga.co.uk");
	PLUGIN_LICENSE("GPL");

	if ( !(matcher_add=in->import("matcher.add")) ) {
		return PLUGIN_ERR_OBJECT;
	}

	if ( !(template_shortrange=in->import("template.shortrange")) ) {
		return PLUGIN_ERR_OBJECT;
	}

	ok+=matcher_add("ip_src", 11,
		ip_src_validate,
		ipaddr_compare,
		in->import("template.ptr"));
	ok+=matcher_add("ip_dst", 10, 
		ip_dst_validate,
		ipaddr_compare,
		in->import("template.ptr"));
	ok+=matcher_add("fragbits", MCOST_NET+6,
		fb_validate,
		fb_compare,
		in->import("template.ptr"));
	ok+=matcher_add("sameip", MCOST_NET+16,
		sip_validate,
		sip_compare,
		NULL);
	ok+=matcher_add("ttl", MCOST_NET+8,
		ttl_validate,
		uci_compare,
		NULL);
	ok+=matcher_add("ip_proto", MCOST_NET+9,
		proto_validate,
		uci_compare,
		NULL);
	ok+=matcher_add("ipopts", MCOST_NET+20,
		ipopts_validate,
		uci_compare,
		NULL);
	ok+=matcher_add("id", MCOST_NET+4,
		id_validate,
		in->import("template.cmp_sr"),
		in->import("template.ptr"));
	ok+=matcher_add("fragoffset", MCOST_NET+6,
		fo_validate,
		in->import("template.cmp_sr"),
		in->import("template.ptr"));
	
	return (ok) ? PLUGIN_ERR_OK : PLUGIN_ERR_FAIL;
}

int _PLUGIN_UNLOAD (int code) {
	return PLUGIN_ERR_OK;
}
